program fpc_pk;
{ FPC_PK   0.0.1

  © 2016 Василий Волченко daesher@mail.ru

  Данная библиотека является свободным программным обеспечением. Вы вправе
  распространять её и/или модифицировать в соответствии с условиями версии 2
  либо по вашему выбору с условиями более поздней версии Стандартной Общественной
  Лицензии Ограниченного Применения GNU, опубликованной Free Software Foundation.

  Мы распространяем эту библиотеку в надежде на то, что она будет вам полезной,
  однако НЕ ПРЕДОСТАВЛЯЕМ НА НЕЕ НИКАКИХ ГАРАНТИЙ, в том числе ГАРАНТИИ ТОВАРНОГО
  СОСТОЯНИЯ ПРИ ПРОДАЖЕ и ПРИГОДНОСТИ ДЛЯ ИСПОЛЬЗОВАНИЯ В КОНКРЕТНЫХ ЦЕЛЯХ. Для
  получения более подробной информации ознакомьтесь со Стандартной Общественной
  Лицензией Ограниченного Применений GNU.

  Вместе с данной библиотекой вы должны были получить экземпляр Стандартной
  Общественной Лицензии Ограниченного Применения GNU. Если вы его не получили,
  сообщите об этом в Free Software Foundation, Inc., 59 Temple
  Place — Suite 330, Boston, MA 02111-1307, USA.
}

{ FPC_PK     0.0.1

  Copyright (C) Vasily Volchenko daesher@mail.ru

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Library General Public License as published by
  the Free Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public License
  for more details.

  You should have received a copy of the GNU Library General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
}


uses Classes, iniparser, fppkutils, SysUtils{,x};//Uncomment to dynamic link

var Path1,Path2,Path3:string;

function FindPath:string;
var
  i, LS: Integer;
  S: String;
begin
  Result:=GetCurrentDir;
  Path1:=Result;Path2:='';Path3:='';
  for i:=1 to Paramcount do
  begin
    S:=trim(ParamStr(i));
    LS:=Length(s);
    if SCmp(S,'-Fu')and (LS>3) then Path2:=copy(s,4,LS-3);
  end;
  for i:=1 to Paramcount do
  begin
    S:=trim(ParamStr(i));
    LS:=Length(s);
    if SCmp(S,'-FE')and (LS>3) then begin Result:=copy(s,4,LS-3);Path3:=Result;end;
  end;
  for i:=1 to Paramcount do
    begin
      S:=trim(ParamStr(i));
      LS:=Length(s);
      if SCmp(S,'-FU')and (LS>3) then Result:=copy(s,4,LS-3);
    end;
end;

function AllParams:string;
var
  i: Integer;
begin
  Result:='';
  for i:=1 to Paramcount do
    Result:=Result+' '+ParamStr(i);
end;

var Path, LR, s:string;
    SL, SL1,LocLibs:TStringList;
    i, k, j, m: Integer;
begin
  Path:=FindPath;
  ExecuteProcess({GetCurrentDir+}FPC,AllParams+' -Cn');
  LR:=PSep(Path)+'link.res';
  if not FileExists(LR) then begin
    LR:=PSep(Path1)+'link.res';
    if not FileExists(LR) then begin
       LR:=PSep(Path2)+'link.res';
         if not FileExists(LR) then begin
           LR:=PSep(Path3)+'link.res';
           if not FileExists(LR) then halt;
         end;
   end;
  end;
  SL:=TStringList.Create;
  SL.LoadFromFile(LR);
  k:=-1;
  for i:=0 to SL.Count-1 do
    if Trim(SL[i])='INPUT(' then begin k:=i;break;end;
  if k<0 then begin
    WriteLn(StdErr,'Error: link.res contains no INPUT section. Exitting.');
    SL.Free;
    halt;
  end;
  m:=-1;
  SL1:=TStringList.Create;
  for i:=k+1 to SL.Count-1 do
    if Trim(SL[i])=')' then begin
      m:=i;break;
    end else SL1.Add(Trim(SL[i]));
  if m<0 then begin
    WriteLn(StdErr,'Error: link.res first INPUT section is not closed. Exitting.');
    SL.Free;SL1.Free;
    halt;
  end;
  LocLibs:=TStringList.Create;
  for i:=0 to SL1.Count-1 do
  begin
    s:=InLib(Trim(SL1[i]));
    if s<>'' then begin
   //   Writeln('Removing:'+SL[i+k+1]);
      SL[i+k+1]:='';
      if LocLibs.IndexOf(s)<0 then LocLibs.Add(s);
    end;
  end;
  SL1.Free;
  if LocLibs.Count>0 then begin
    j:=-1;
    for i:=m+1 to SL.Count-1 do
      if Trim(SL[i])='INPUT(' then begin j:=i+1;break;end;
    if j<0 then j:=m;//OK, no second input section. Let's add to first
    for i:=0 to LocLibs.Count-1 do
      SL.Insert(j,'-l'+LocLibs[i]);
  end;
  LocLibs.Free;
  SL.SaveToFile(LR);
 // readln;
  ExecuteProcess(PSep(ExtractFilePath(LR))+{$ifdef unix}'ppas.sh'{$else}'ppas.bat'{$endif},'')

end.

